package com.cnblogs.keyindex.chat.model;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import com.cnblogs.keyindex.chat.formatters.FormatterFactory;
import com.cnblogs.keyindex.chat.formatters.Formatter;

public class Chat {

	private String author;
	private String content;
	private String generalTime;
	private String id;
	private String headImageUrl;
	private final String DEFAULT_HEADER_IMG_URL = "http://pic.cnblogs.com/face/sample_face.gif";

	private String contentUrl;

	private boolean isShining = false;
	private boolean isNewPerson = false;
	private boolean needLoadComments = false;

	private List<Comment> comments;

	public Chat() {
		comments = new ArrayList<Comment>();
	}

	public boolean IsDefaultHeaderImage() {
		return headImageUrl.contentEquals(DEFAULT_HEADER_IMG_URL);
	}

	/**
	 * ȡǷΪ
	 * 
	 * @return True ʾ»Ա
	 */
	public boolean IsNewPerson() {
		return isNewPerson;
	}

	/**
	 * ǷΪ
	 * 
	 * @param value
	 *            Trueʾ»Ա
	 */
	public void setIsNewPerson(boolean value) {
		isNewPerson = value;
	}

	/**
	 * Ƿ
	 * 
	 * @return
	 */
	public boolean IsShining() {
		return isShining;
	}

	/**
	 * 
	 * 
	 * @param value
	 *            Trueʾѻ
	 */
	public void setIsShining(boolean value) {
		isShining = value;
	}

	/**
	 * URL Դַ
	 * 
	 * @param value
	 */
	public void setContentUrl(String value) {
		contentUrl = value;
	}

	/**
	 * ȡURLԴַ
	 * 
	 * @return
	 */
	public String getContentUrl() {
		return contentUrl;
	}

	/**
	 * ȡͷURLַ
	 * 
	 * @return
	 */
	public String getHeadImageUrl() {
		return headImageUrl;
	}

	/**
	 * ͷURLַ
	 * 
	 * @param url
	 */
	public void setHeadImageUrl(String url) {
		headImageUrl = url;
	}

	/**
	 * ȡϢ
	 * 
	 * @return
	 */
	public List<Comment> getCommentsMessage() {
		return comments;
	}

	/**
	 * 
	 * 
	 * @param value
	 */
	public void addComment(Comment value) {
		value.setParentId(id);
		comments.add(value);
	}

	/**
	 * Ӷ۵бβ
	 * 
	 * @param list
	 */
	public void addAllComments(Collection<Comment> list) {
		if (list != null) {
			for (Comment item : list) {
				item.setParentId(id);
			}
			comments.addAll(list);

		}
	}

	/**
	 * Ӷ۵ָλ
	 * 
	 * @param postion
	 *            ָλ
	 * @param list
	 */
	public void addAllComments(int postion, Collection<Comment> list) {
		if (postion >= 0 && postion < comments.size() && list != null) {
			for (Comment item : list) {
				item.setParentId(id);
			}
			comments.addAll(postion, list);
		}
	}

	/**
	 * 
	 */
	public void clearComments() {
		comments.clear();
	}

	public String getChatId() {
		return id;
	}

	public void setChatId(String value) {
		id = value;
	}

	public String getGeneralTime() {
		return generalTime;
	}

	public void setGeneralTime(String value) {
		generalTime = value;
	}

	public String getAuthorName() {
		return author;
	}

	public void setAuthorName(String name) {
		author = name;
	}

	public String getContent() {
		return content;
	}

	public void setContent(String value) {
		content = value;
	}

	public void setNeedLoadComments(boolean needLoadComments) {
		this.needLoadComments = needLoadComments;
	}

	public boolean isNeedLoadComments() {
		return needLoadComments;
	}

	public boolean hasComments() {
		return comments.size() > 0;
	}

	public static List<Chat> parse(String content) {
		Formatter formatter = FormatterFactory.getInstance().getFormatter(
				Chat.class.getName());
		@SuppressWarnings("unchecked")
		List<Chat> list = (List<Chat>) formatter.format(content);
		return list;
	}

}
