package com.cnblogs.keyindex.business;

import java.lang.ref.SoftReference;
import java.util.HashMap;

import android.graphics.drawable.Drawable;
import android.os.Handler;

import com.loopj.android.http.AsyncHttpClient;
import com.loopj.android.http.ImageHttpResponseHandler;


public class ImageLoader {

	/**
	 * FlashMessage Ҫˢ Բ FlashMessageлͼƬ
	 */
	private HashMap<String, SoftReference<Drawable>> imagesCache;
	private AsyncHttpClient httpClient;
	private final Handler handler = new Handler();

	public ImageLoader() {
		httpClient = new AsyncHttpClient();
		imagesCache = new HashMap<String, SoftReference<Drawable>>();
	}

	public Drawable getImage(String key) {
		Drawable drawable = null;
		if (imagesCache.containsKey(key)) {
			SoftReference<Drawable> softReference = imagesCache.get(key);
			if (softReference != null)
				drawable = softReference.get();
		}
		return drawable;

	}

	/**
	 * ͷأAdapter  ķᱻظá ڲῪ߳˶εû߳ ΪҪ
	 * 账ΪUI߳ԴԲֱ߳ӵ ImageDownloaded ӿڣҪHandlerƣ
	 * ÿһ߳ҪӦһ Handler ʵڴ߳ڵ Ϣ
	 * 
	 * @param url
	 *            ͷUrlַ
	 * @param location
	 *            λListе
	 * @param onImageDownLoadedListener
	 *            ÿεôݽͼƬغ ص
	 * @return
	 */
	public void asynLoaderImage(final String url, int locationTag,
			final ImageDownLoadedListener listener) {

//		// ʾδͶ ,ҪأѾҪظݣԼhttp
//		if (!imagesCache.containsKey(url)) {
//			imagesCache.put(url, null);
			downloadImage(url, locationTag, listener);
//		} 

	}

	private void downloadImage(final String url, final int locationTag,
			final ImageDownLoadedListener listener) {

		httpClient.get(url, new ImageHttpResponseHandler() {

			@Override
			public void onSuccess(final Drawable image) {
				imagesCache.put(url, new SoftReference<Drawable>(image));
				handler.post(new Runnable() {

					@Override
					public void run() {
						if (listener != null) {
							listener.onImageLoaded(image, locationTag);
						}
					}
				});
			}

		});
	}

	/**
	 * ͼƬؼڴͼƬɺĻص
	 * 
	 * @author linzijun
	 * 
	 */
	public interface ImageDownLoadedListener {
		/**
		 * 
		 * @param imageDrawable
		 *            صͼƬ
		 * @param location
		 *            ȡչʾͼƬViewĶӦλá
		 */
		public void onImageLoaded(Drawable imageDrawable, int locationTag);
	}

}
